import {IPCAnswer, IPCListenChannels} from "../RawConstants";

type IPCListen = {
    channel: IPCListenChannels,
    fn: (message: IPCAnswer, ...args: any) => void,
}

export default class IPCListener {
    private static attachments: Map<number, IPCListen> = new Map<number, IPCListen>();



    public static attach()
    {
        for(let c of Object.keys(IPCListenChannels))
        {
            window.api.listen((c as unknown as IPCListenChannels), (event, message: IPCAnswer, ...args: any) => {
                for(let [a, listener] of this.attachments)
                {
                    listener.fn(message, ...args);
                }
            });
        }
    }
}